/*
Copyright 2021.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

package v1alpha1

import (
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
)

// EDIT THIS FILE!  THIS IS SCAFFOLDING FOR YOU TO OWN!
// NOTE: json tags are required.  Any new fields you add must have json tags for the fields to be serialized.

const (
	LibreContextProviderS3Type = "S3"
)

type LibreContextProvider struct {
	// +required
	Name string `json:"name"`
	// +required
	// +kubebuilder:validation:Enum=S3
	Type string `json:"type"`
}

// LibreContextSpec defines the desired state of LibreContext
type LibreContextSpec struct {
	// +optional
	Providers []LibreContextProvider `json:"providers,omitempty"`
}

// LibreContextStatus defines the observed state of LibreContext
type LibreContextStatus struct {
}

//+kubebuilder:object:root=true
//+kubebuilder:subresource:status

// LibreContext is the Schema for the librecontexts API
type LibreContext struct {
	metav1.TypeMeta   `json:",inline"`
	metav1.ObjectMeta `json:"metadata,omitempty"`

	Spec   LibreContextSpec   `json:"spec,omitempty"`
	Status LibreContextStatus `json:"status,omitempty"`
}

//+kubebuilder:object:root=true

// LibreContextList contains a list of LibreContext
type LibreContextList struct {
	metav1.TypeMeta `json:",inline"`
	metav1.ListMeta `json:"metadata,omitempty"`
	Items           []LibreContext `json:"items"`
}

func init() {
	SchemeBuilder.Register(&LibreContext{}, &LibreContextList{})
}
