/*
Copyright 2021.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

package v1alpha1

import (
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
)

// EDIT THIS FILE!  THIS IS SCAFFOLDING FOR YOU TO OWN!
// NOTE: json tags are required.  Any new fields you add must have json tags for the fields to be serialized.

// S3ProviderSpec defines the desired state of S3Provider
type S3ProviderSpec struct {
	//+required
	Endpoint string `json:"endpoint,omitempty"`
	//+required
	Region string `json:"region,omitempty"`
	//+required
	AccessKey string `json:"accessKey,omitempty"`
	//+required
	SecretKey string `json:"secretKey,omitempty"`
	//+optional
	Insecure bool `json:"insecure,omitempty"`
}

// S3ProviderStatus defines the observed state of S3Provider
type S3ProviderStatus struct {
	// INSERT ADDITIONAL STATUS FIELD - define observed state of cluster
	// Important: Run "make" to regenerate code after modifying this file
}

//+kubebuilder:object:root=true
//+kubebuilder:subresource:status

// S3Provider is the Schema for the s3providers API
type S3Provider struct {
	metav1.TypeMeta   `json:",inline"`
	metav1.ObjectMeta `json:"metadata,omitempty"`

	Spec   S3ProviderSpec   `json:"spec,omitempty"`
	Status S3ProviderStatus `json:"status,omitempty"`
}

//+kubebuilder:object:root=true

// S3ProviderList contains a list of S3Provider
type S3ProviderList struct {
	metav1.TypeMeta `json:",inline"`
	metav1.ListMeta `json:"metadata,omitempty"`
	Items           []S3Provider `json:"items"`
}

func init() {
	SchemeBuilder.Register(&S3Provider{}, &S3ProviderList{})
}
